<template>
  <div
    id="topbar"
    class="grid gap-5 lg:grid-cols-5 md:grid-cols-4 sm:grid-cols-3"
  >
    <el-select
      v-if="budget_years.length > 0"
      v-model="budgetYearsSelected"
      filterable
      placeholder="ปีงบประมาณ"
    >
      <el-option
        v-for="item in budget_years"
        :key="item.id"
        :label="item.year"
        :value="item.id"
      >
      </el-option>
    </el-select>
    <el-select
      v-if="stargics.length > 0"
      v-model="stargicsSelected"
      filterable
      placeholder="ยุทธศาสตร์"
    >
      <el-option
        v-for="item in stargics"
        :key="item.id"
        :label="item.name"
        :value="item.id"
      >
        <div class="d-flex justify-between">
          <span>ยุทธศาสตร์ที่ : {{ item.number }} &nbsp;</span>
          <span>{{ item.name }} &nbsp;</span>
          <span>{{ item.lastname }} </span>
        </div>
      </el-option>
    </el-select>
  </div>
</template>

<script>
import { onMounted, reactive, ref, toRefs, watch } from "vue";
export default {
  props: {
    stargics: Array,
    budget_years: Array,
  },

  setup(props, { emit }) {
    const { stargics, budget_years } = toRefs(props);
    const stargicsSelected = ref(parseInt(route()?.params?.stargicId) || null);
    const budgetYearsSelected = ref(
      parseInt(route()?.params?.budgetYearId) || 1
    );
    onMounted(() => {});
    watch([budgetYearsSelected, stargicsSelected], (value, prevValue) => {
      const budgetYears = value[0];
      const stargics = value[1];
      if (budgetYears && budgetYears != prevValue[0]) {
        emit("budgetYearsChange", budgetYears);
      }
      if (stargics && stargics != prevValue[1]) {
        emit("stargicsChange", {
          budgetYearId: budgetYearsSelected.value,
          stargicId: stargics,
        });
      }
    });
    return {
      stargics,
      budget_years,
      stargicsSelected,
      budgetYearsSelected,
    };
  },
};
</script>

<style>
</style>
